#ifndef __AOPP_H__
#define __AOPP_H__

#include "ao/ao.h"
#include <cstdint>

namespace AOPP {

    typedef ao_sample_format AOSampleFormat;
    typedef ao_info AOInfo;

    ////////////////////////////////////////////////////////////////////////////
    class AOOptions {
        friend class AODriver;

    public:
        AOOptions();
        ~AOOptions();
        int append( const char *key, const char *value );
        void print_options(void);

    private:
        ao_option *options;

        };
    

    ////////////////////////////////////////////////////////////////////////////
    class AODevice {
    public:
        AODevice( ao_device * dev );
        int play( char *output_samples, uint32_t num_bytes );
        int close( void );

    private:
        AODevice();
        ao_device *device;
        };

    ////////////////////////////////////////////////////////////////////////////
    class AODriver {
    public:
        AODriver( int id );
        AODevice * open_live( AOSampleFormat *format, AOOptions *options );
        AODevice * open_file( const char *filename, int overwrite, AOSampleFormat *format, AOOptions *options );
        AOInfo * driver_info( void );
#if 0
// ao_file_extension not in my libao ?
        const char * file_extension( void );
#endif

        static int get_driver_id( const char *short_name );

    private:
        AODriver();
        int driver_id;
        };

    }

#endif
